package com.wuban.tron.explore.entity.example;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 区块头信息表 查询条件example类
 * @author sky
 * @date 2020-11-03
 */
public class BlockHeaderExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public BlockHeaderExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

	        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria)this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria)this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria)this;
        }
		
		public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria)this;
        }
			
	            public Criteria andBlockIdIsNull() {
            addCriterion("block_id is null");
            return (Criteria)this;
        }

        public Criteria andBlockIdIsNotNull() {
            addCriterion("block_id is not null");
            return (Criteria)this;
        }

        public Criteria andBlockIdEqualTo(String value) {
            addCriterion("block_id =", value, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotEqualTo(String value) {
            addCriterion("block_id <>", value, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdIn(List<String> values) {
            addCriterion("block_id in", values, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotIn(List<String> values) {
            addCriterion("block_id not in", values, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdBetween(String value1, String value2) {
            addCriterion("block_id between", value1, value2, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotBetween(String value1, String value2) {
            addCriterion("block_id not between", value1, value2, "blockId");
            return (Criteria)this;
        }
		
			
		public Criteria andBlockIdLike(String value) {
            addCriterion("block_id like", value, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotLike(String value) {
            addCriterion("block_id not like", value, "blockId");
            return (Criteria)this;
        }
	            public Criteria andNumberIsNull() {
            addCriterion("number is null");
            return (Criteria)this;
        }

        public Criteria andNumberIsNotNull() {
            addCriterion("number is not null");
            return (Criteria)this;
        }

        public Criteria andNumberEqualTo(Long value) {
            addCriterion("number =", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberNotEqualTo(Long value) {
            addCriterion("number <>", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberIn(List<Long> values) {
            addCriterion("number in", values, "number");
            return (Criteria)this;
        }

        public Criteria andNumberNotIn(List<Long> values) {
            addCriterion("number not in", values, "number");
            return (Criteria)this;
        }

        public Criteria andNumberBetween(Long value1, Long value2) {
            addCriterion("number between", value1, value2, "number");
            return (Criteria)this;
        }

        public Criteria andNumberNotBetween(Long value1, Long value2) {
            addCriterion("number not between", value1, value2, "number");
            return (Criteria)this;
        }
		
		public Criteria andNumberGreaterThan(Long value) {
            addCriterion("number >", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberGreaterThanOrEqualTo(Long value) {
            addCriterion("number >=", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberLessThan(Long value) {
            addCriterion("number <", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberLessThanOrEqualTo(Long value) {
            addCriterion("number <=", value, "number");
            return (Criteria)this;
        }
			
	            public Criteria andTxTrieRootIsNull() {
            addCriterion("tx_trie_root is null");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootIsNotNull() {
            addCriterion("tx_trie_root is not null");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootEqualTo(String value) {
            addCriterion("tx_trie_root =", value, "txTrieRoot");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootNotEqualTo(String value) {
            addCriterion("tx_trie_root <>", value, "txTrieRoot");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootIn(List<String> values) {
            addCriterion("tx_trie_root in", values, "txTrieRoot");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootNotIn(List<String> values) {
            addCriterion("tx_trie_root not in", values, "txTrieRoot");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootBetween(String value1, String value2) {
            addCriterion("tx_trie_root between", value1, value2, "txTrieRoot");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootNotBetween(String value1, String value2) {
            addCriterion("tx_trie_root not between", value1, value2, "txTrieRoot");
            return (Criteria)this;
        }
		
			
		public Criteria andTxTrieRootLike(String value) {
            addCriterion("tx_trie_root like", value, "txTrieRoot");
            return (Criteria)this;
        }

        public Criteria andTxTrieRootNotLike(String value) {
            addCriterion("tx_trie_root not like", value, "txTrieRoot");
            return (Criteria)this;
        }
	            public Criteria andWitnessAddressIsNull() {
            addCriterion("witness_address is null");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressIsNotNull() {
            addCriterion("witness_address is not null");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressEqualTo(String value) {
            addCriterion("witness_address =", value, "witnessAddress");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressNotEqualTo(String value) {
            addCriterion("witness_address <>", value, "witnessAddress");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressIn(List<String> values) {
            addCriterion("witness_address in", values, "witnessAddress");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressNotIn(List<String> values) {
            addCriterion("witness_address not in", values, "witnessAddress");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressBetween(String value1, String value2) {
            addCriterion("witness_address between", value1, value2, "witnessAddress");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressNotBetween(String value1, String value2) {
            addCriterion("witness_address not between", value1, value2, "witnessAddress");
            return (Criteria)this;
        }
		
			
		public Criteria andWitnessAddressLike(String value) {
            addCriterion("witness_address like", value, "witnessAddress");
            return (Criteria)this;
        }

        public Criteria andWitnessAddressNotLike(String value) {
            addCriterion("witness_address not like", value, "witnessAddress");
            return (Criteria)this;
        }
	            public Criteria andParentHashIsNull() {
            addCriterion("parentHash is null");
            return (Criteria)this;
        }

        public Criteria andParentHashIsNotNull() {
            addCriterion("parentHash is not null");
            return (Criteria)this;
        }

        public Criteria andParentHashEqualTo(String value) {
            addCriterion("parentHash =", value, "parentHash");
            return (Criteria)this;
        }

        public Criteria andParentHashNotEqualTo(String value) {
            addCriterion("parentHash <>", value, "parentHash");
            return (Criteria)this;
        }

        public Criteria andParentHashIn(List<String> values) {
            addCriterion("parentHash in", values, "parentHash");
            return (Criteria)this;
        }

        public Criteria andParentHashNotIn(List<String> values) {
            addCriterion("parentHash not in", values, "parentHash");
            return (Criteria)this;
        }

        public Criteria andParentHashBetween(String value1, String value2) {
            addCriterion("parentHash between", value1, value2, "parentHash");
            return (Criteria)this;
        }

        public Criteria andParentHashNotBetween(String value1, String value2) {
            addCriterion("parentHash not between", value1, value2, "parentHash");
            return (Criteria)this;
        }
		
			
		public Criteria andParentHashLike(String value) {
            addCriterion("parentHash like", value, "parentHash");
            return (Criteria)this;
        }

        public Criteria andParentHashNotLike(String value) {
            addCriterion("parentHash not like", value, "parentHash");
            return (Criteria)this;
        }
	            public Criteria andVersionIsNull() {
            addCriterion("version is null");
            return (Criteria)this;
        }

        public Criteria andVersionIsNotNull() {
            addCriterion("version is not null");
            return (Criteria)this;
        }

        public Criteria andVersionEqualTo(Integer value) {
            addCriterion("version =", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionNotEqualTo(Integer value) {
            addCriterion("version <>", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionIn(List<Integer> values) {
            addCriterion("version in", values, "version");
            return (Criteria)this;
        }

        public Criteria andVersionNotIn(List<Integer> values) {
            addCriterion("version not in", values, "version");
            return (Criteria)this;
        }

        public Criteria andVersionBetween(Integer value1, Integer value2) {
            addCriterion("version between", value1, value2, "version");
            return (Criteria)this;
        }

        public Criteria andVersionNotBetween(Integer value1, Integer value2) {
            addCriterion("version not between", value1, value2, "version");
            return (Criteria)this;
        }
		
		public Criteria andVersionGreaterThan(Integer value) {
            addCriterion("version >", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionGreaterThanOrEqualTo(Integer value) {
            addCriterion("version >=", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionLessThan(Integer value) {
            addCriterion("version <", value, "version");
            return (Criteria)this;
        }

        public Criteria andVersionLessThanOrEqualTo(Integer value) {
            addCriterion("version <=", value, "version");
            return (Criteria)this;
        }
			
	            public Criteria andTimestampIsNull() {
            addCriterion("timestamp is null");
            return (Criteria)this;
        }

        public Criteria andTimestampIsNotNull() {
            addCriterion("timestamp is not null");
            return (Criteria)this;
        }

        public Criteria andTimestampEqualTo(Long value) {
            addCriterion("timestamp =", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampNotEqualTo(Long value) {
            addCriterion("timestamp <>", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampIn(List<Long> values) {
            addCriterion("timestamp in", values, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampNotIn(List<Long> values) {
            addCriterion("timestamp not in", values, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampBetween(Long value1, Long value2) {
            addCriterion("timestamp between", value1, value2, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampNotBetween(Long value1, Long value2) {
            addCriterion("timestamp not between", value1, value2, "timestamp");
            return (Criteria)this;
        }
		
		public Criteria andTimestampGreaterThan(Long value) {
            addCriterion("timestamp >", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampGreaterThanOrEqualTo(Long value) {
            addCriterion("timestamp >=", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampLessThan(Long value) {
            addCriterion("timestamp <", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampLessThanOrEqualTo(Long value) {
            addCriterion("timestamp <=", value, "timestamp");
            return (Criteria)this;
        }
			
	            public Criteria andWitnessSignatureIsNull() {
            addCriterion("witness_signature is null");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureIsNotNull() {
            addCriterion("witness_signature is not null");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureEqualTo(String value) {
            addCriterion("witness_signature =", value, "witnessSignature");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureNotEqualTo(String value) {
            addCriterion("witness_signature <>", value, "witnessSignature");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureIn(List<String> values) {
            addCriterion("witness_signature in", values, "witnessSignature");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureNotIn(List<String> values) {
            addCriterion("witness_signature not in", values, "witnessSignature");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureBetween(String value1, String value2) {
            addCriterion("witness_signature between", value1, value2, "witnessSignature");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureNotBetween(String value1, String value2) {
            addCriterion("witness_signature not between", value1, value2, "witnessSignature");
            return (Criteria)this;
        }
		
			
		public Criteria andWitnessSignatureLike(String value) {
            addCriterion("witness_signature like", value, "witnessSignature");
            return (Criteria)this;
        }

        public Criteria andWitnessSignatureNotLike(String value) {
            addCriterion("witness_signature not like", value, "witnessSignature");
            return (Criteria)this;
        }
	            public Criteria andTransactionVolumeIsNull() {
            addCriterion("transaction_volume is null");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeIsNotNull() {
            addCriterion("transaction_volume is not null");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeEqualTo(Integer value) {
            addCriterion("transaction_volume =", value, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeNotEqualTo(Integer value) {
            addCriterion("transaction_volume <>", value, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeIn(List<Integer> values) {
            addCriterion("transaction_volume in", values, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeNotIn(List<Integer> values) {
            addCriterion("transaction_volume not in", values, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeBetween(Integer value1, Integer value2) {
            addCriterion("transaction_volume between", value1, value2, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeNotBetween(Integer value1, Integer value2) {
            addCriterion("transaction_volume not between", value1, value2, "transactionVolume");
            return (Criteria)this;
        }
		
		public Criteria andTransactionVolumeGreaterThan(Integer value) {
            addCriterion("transaction_volume >", value, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeGreaterThanOrEqualTo(Integer value) {
            addCriterion("transaction_volume >=", value, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeLessThan(Integer value) {
            addCriterion("transaction_volume <", value, "transactionVolume");
            return (Criteria)this;
        }

        public Criteria andTransactionVolumeLessThanOrEqualTo(Integer value) {
            addCriterion("transaction_volume <=", value, "transactionVolume");
            return (Criteria)this;
        }
			
	            public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria)this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria)this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria)this;
        }
		
		public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria)this;
        }
			
	    	public Criteria andFieldIsNull(final String fieldName) {
            addCriterion(fieldName + " is null");
            return (Criteria) this;
        }
		
	public Criteria andFieldIsNotNull(final String fieldName) {
            addCriterion(fieldName + " is not null");
            return (Criteria) this;
        }
		
	public Criteria andFieldEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " = ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <> ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " in ", values, fieldName);
           return (Criteria) this;
        }
		
	public Criteria andFieldNotIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " not in ", values, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + " between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + "  not between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldGreaterThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " > ", fieldValue, fieldName);
            return (Criteria) this;
        }

	public Criteria andFieldGreaterThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " >= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLessThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " < ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldLessThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + " like ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + "  not like ", fieldValue, fieldName);
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}
